#!/usr/bin/env python
#
# MARK - Mutual Authentication to Resist Keylogging
#
# Copyright (C) 2013  Johannes Goetzfried <johannes@jgoetzfried.de>
#
# based on former c++ code by
#    Copyright (C) 2013  Hans Spath <tresor@hans-spath.de>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import curses;
import sys;

import config;
import ui.basic;
import ui.dialog;
import ui.action;


h, w = ui.basic.ui().gethw()

if h < 24 or w < 80:
	ui.basic.ui().end();
	print 'Terminal is too small (has to be at least 80x24).'
	sys.exit(0);


header = ui.dialog.Header('MARK ' + config.mark_version + ' - Mutual Authentication to Resist Keylogging');

main = ui.dialog.MainPanel('Choose', [
	('<F1>', curses.KEY_F1, 'Boot existing System', ui.action.mainActionBoot),
	('<F2>', curses.KEY_F2, 'Install new System', ui.action.mainActionInstall),
	('<F3>', curses.KEY_F3, 'Configuration or Recovery', ui.action.mainActionSetup),
	('<F10>', curses.KEY_F10, 'Reboot', ui.action.mainActionReboot)
]);

header.draw();
main.draw();
