# MARK - Communication with the TPM
#
# Copyright (C) 2013  Johannes Goetzfried <johannes@jgoetzfried.de>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import config;
import subprocess;

class TpmError(Exception):
	def __init__(self, value):
		self.value = value;
	def __str__(self):
		return repr(self.value);

class Tpm:
	def __init__(self):
		self._pcr = '';

		with open('/sys/class/misc/tpm0/device/owned', 'r') as f:
			ret = f.readline();
			if ret[0] != '1':
				raise TpmError('You have to take ownership of your TPM first!');

		for p in config.tpm_pcrs:
			self._pcr = self._pcr + ' -p ' + str(p);

	def seal(self, dst, src):
		cmd = 'cat ' + src + ' 2> /dev/null ';
		cmd = cmd + '| tpm_sealdata -l none -z -o ' + dst + self._pcr;
		cmd = cmd + ' > /dev/null 2>&1';
		subprocess.check_call(cmd, shell=True);

	def unseal(self, dst, src):
		cmd = 'tpm_unsealdata -l none -z -i ' + src + ' > ' + dst + ' 2> /dev/null';
		subprocess.check_call(cmd, shell=True);

